#pragma once

#include <Writer.h>
#include <Vec3.h>

class Chunk;
class Block;
class Entity;

class NetworkMessage
{
private:
	char* address;
	char addressLength;
	bool broadcast;
	char* message;
	bool msgDelete;
	int msgLength;
	bool useBackground;

public:
	NetworkMessage();
	~NetworkMessage();

	void addressChunck(Chunk* zChunk);
	void addressEntity(Entity* zEntity);
	void addressBlock(Block* zBlock);;
	void addressDimension();
	void openDialog(Framework::Text dialogName);
	void addressGui(Framework::Text elementId);
	void setMessage(char* msg, int length, bool deleteMsg);
	void setUseBackground();
	void sendToAll();

	void writeTo(Framework::StreamWriter* zWriter) const;
	bool isBroadcast() const;
	bool isEmpty() const;
	bool isUseBackground() const;
};